#ifndef __ALLOC
#define __ALLOC

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef size_t
#undef HANDLE
#define size_t unsigned long
#define HANDLE unsigned short

#undef NULL
#undef H_NULL
#define NULL ((void*)0)
#define H_NULL 0

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

void *alloca(long);  /* This function are open-coded in GCC itself */

#define FreeHandles _rom_call(short,(void),23B)
#define HeapAlloc _rom_call(unsigned short,(long),90)
#define HeapAllocHigh _rom_call(unsigned short,(long),92)
#define HeapAllocThrow _rom_call(unsigned short,(long),93)
#define HeapAllocHighThrow _rom_call(unsigned short,(long),94)
#define HeapAvail _rom_call(unsigned long,(void),8F)
#define HeapCompress _rom_call(void,(void),95)
#define HeapFree _rom_call(void,(short),97)
#define HeapFreeIndir _rom_call(void,(void*),98)
#define HeapGetLock _rom_call(short,(short),9B)
#define HeapLock _rom_call(unsigned short,(short),9A)
#define HeapMax _rom_call(unsigned long,(void),9C)
#define HeapMoveHigh _rom_call(unsigned short,(short),A0)
#define HeapRealloc _rom_call(unsigned short,(short,long),9D)
#define HeapSize _rom_call(unsigned short,(short),9E)
#define HeapUnlock _rom_call(unsigned short,(short),9F)
#define HLock _rom_call(void*,(short),99)
#define HeapDeref _rom_call(void*,(short),96)
#define HeapAllocPtr _rom_call(void*,(long),A2)
#define HeapFreePtr _rom_call(void,(void*),A3)
#define HeapAllocESTACK _rom_call(unsigned short,(long),91)
#define HeapEnd _rom_call(void*,(void),A1)
#define HeapGetHandle _rom_call(unsigned short,(void),239)
#define HeapPtrToHandle _rom_call(unsigned short,(void*),23A)

#ifdef DOORS

short FreeHandles(void);
unsigned short HeapAlloc(long);
unsigned short HeapAllocHigh(long);
unsigned short HeapAllocThrow(long);
unsigned short HeapAllocHighThrow(long);
unsigned long HeapAvail(void);
void HeapCompress(void);
void HeapFree(short);
void HeapFreeIndir(void*);
short HeapGetLock(short);
unsigned short HeapLock(short);
unsigned long HeapMax(void);
unsigned short HeapMoveHigh(short);
unsigned short HeapRealloc(short,long);
unsigned short HeapSize(short);
unsigned short HeapUnlock(short);
void *HLock(short);
void *HeapDeref(short);
void *HeapAllocPtr(long);
void HeapFreePtr(void*);
unsigned short HeapAllocESTACK(long);
void *HeapEnd(void);
unsigned short HeapGetHandle(void);
unsigned short HeapPtrToHandle(void*);

#endif

#ifndef __STDALLOC
#define __STDALLOC

#define malloc _rom_call(void*,(long),A2)
#define free _rom_call(void,(void*),A3)

#define calloc ((void*(*)(short,short))(short[]){0x4E56,0,0x302E,8,0xC0EE,10, \
  0x2F00,0x2078,0xC8,0x2068,0x288,0x4E90,0x2008,0x6710,0x4267,0x2F08,0x2078, \
  0xC8,0x2068,0x9F0,0x4E90,0x6006,0x207C,0,0,0x4E5E,0x4E75})

#define realloc ((void*(*)(void*,long))(long[]){0x4E560000,0x48E71030, \
  0x206E0008,0x266E000C,0x3628FFFE,0x247800C8,0x3F03206A,0x027C4E90, \
  0x486B0002,0x3F03206A,0x2744E90,0x206A0264,0x4A406606,0x4E9091C8, \
  0x60044E90,0x54884CEE,0xC08FFF4,0x4E5E4E75})

#ifdef DOORS

void *malloc(long);
void free(void*);

#endif

#endif

#endif
