#ifndef __COMPAT
#define __COMPAT

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#define TIOS_entries (*(*(unsigned long**)0xC8-1))
#define AMS_1xx (TIOS_entries<1000)
#define AMS_2xx (TIOS_entries>1000)

#ifdef DOORS

#define _ram_call(n,type) ({register long __r; \
  asm("move.l #_RAM_CALL_"## #n ##",%0"::"g"(__r)); (type)__r;})

#define CALCULATOR (*_ram_call(0,char*))
#define ROM_base _ram_call(3,void*)

#define LCD_WIDTH _ram_call(1,unsigned short)
#define LCD_HEIGHT _ram_call(2,unsigned short)
#define LCD_LINE_BYTES _ram_call(4,unsigned short)

#define KEY_LEFT _ram_call(5,short)
#define KEY_RIGHT _ram_call(6,short)
#define KEY_UP _ram_call(7,short)
#define KEY_DOWN _ram_call(8,short)
#define KEY_UPRIGHT _ram_call(9,short)
#define KEY_DOWNLEFT _ram_call(A,short)
#define KEY_DIAMOND _ram_call(B,short)
#define KEY_SHIFT _ram_call(D,short)

#define TI89 (!CALCULATOR)
#define TI92PLUS CALCULATOR

#else

#define CALCULATOR (ROM_base==(void*)0x400000)
#define ROM_base ((void*)((*(unsigned long*)0xC8)&0x600000))

#define LCD_WIDTH (CALCULATOR?240:160)
#define LCD_HEIGHT (CALCULATOR?128:100)
#define LCD_LINE_BYTES (CALCULATOR?30:20)

#define KEY_LEFT (CALCULATOR?337:338)
#define KEY_RIGHT (CALCULATOR?340:344)
#define KEY_UP (CALCULATOR?338:337)
#define KEY_DOWN (CALCULATOR?344:340)
#define KEY_UPRIGHT (CALCULATOR?342:345)
#define KEY_DOWNLEFT (CALCULATOR?345:342)
#define KEY_DIAMOND (CALCULATOR?8192U:16384U)
#define KEY_SHIFT (CALCULATOR?16384U:8192U)

#define TI89 (ROM_base==(void*)0x200000)
#define TI92PLUS (ROM_base==(void*)0x400000)

#endif

#endif
