#ifndef __DIALOGS
#define __DIALOGS

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef HANDLE
#undef NULL
#undef H_NULL
#undef CENTER
#define HANDLE unsigned short
#define NULL ((void*)0)
#define H_NULL 0
#define CENTER -1

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#ifndef __BUTTONS
#define __BUTTONS

enum Buttons {BT_NONE,BT_OK,BT_SAVE,BT_YES,BT_CANCEL,BT_NO,BT_GOTO};

#endif

#define NoCallBack ((short(*)(short,long))(long[]){0x70014E75})
/* NoCallBack is not in TIOS jump table on AMS 2.xx! */

#define DlgMessage _rom_call(short,(char*,char*,short,short),1B4)
#define DialogNew _rom_call(unsigned short,(short,short,short(*)(short,long)),34)
#define DialogDo _rom_call(short,(short,short,short,char*,short*),32)
#define Dialog _rom_call(short,(void*,short,short,char*,short*),30)
#define DialogAdd _rom_call(short,(short,short,short,short,short,...),33)

#ifdef DOORS

short DlgMessage(char*,char*,short,short);
unsigned short DialogNew(short,short,short(*)(short,long));
short DialogDo(short,short,short,char*,short*);
short Dialog(void*,short,short,char*,short*);
short DialogAdd(short,short,short,short,short,...);

#endif

#define DialogNewSimple(w,h) DialogNew(w,h,NoCallBack)

#define DialogAddText(h,x,y,t) \
  DialogAdd(h,0,x,y,7,(char*)(t))
#define DialogAddRequest(h,x,y,t,o,m,w) \
  DialogAdd(h,0,x,y,2,(char*)(t),(short)(o),(short)(m),(short)(w))
#define DialogAddPulldown(h,x,y,t,p,i) \
  DialogAdd(h,2,x,y,14,(char*)(t),(short)(p),(short)(i))
#define DialogAddTitle(h,t,l,r) \
  DialogAdd(h,0,0,0,8,(char*)(t),(short)(l),(short)(r))

#define DialogAddScroll(h,x,y,w,g,f,t,p,u,m) \
  DialogAdd(h,0,x,y,3,(short)w,(short)g,(short)f,(short)t,(short)p,(short)u,(short)m)

#endif
