#ifndef __KBD
#define __KBD

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef NULL
#define NULL ((void*)0)

enum Arrows {ARROW_UP=1,ARROW_LEFT=2,ARROW_DOWN=3,ARROW_RIGHT=4};
enum StatKeys {STAT_2ND=1,STAT_DIAMOND=2,STAT_SHIFT=3,STAT_HAND=4};

enum CommonKeys {KEY_F1=268,KEY_F2=269,KEY_F3=270,KEY_F4=271,KEY_F5=272,
  KEY_F6=273,KEY_F7=274,KEY_F8=275,KEY_ESC=264,KEY_QUIT=4360,KEY_APPS=265,
  KEY_SWITCH=4361,KEY_MODE=266,KEY_BACKSPACE=257,KEY_INS=4353,KEY_CLEAR=263,
  KEY_VARLNK=4141,KEY_CHAR=4139,KEY_ENTER=13,KEY_ENTRY=4109,KEY_STO=258,
  KEY_RCL=4354,KEY_SIGN=173,KEY_MATH=4149,KEY_MEM=4150,KEY_ON=267,
  KEY_OFF=4363};

#ifndef __SCR_RECT
#define __SCR_RECT

typedef union
  {
    struct
      {
        unsigned char x0,y0,x1,y1;
      } xy;
    unsigned long l;
  } SCR_RECT;

#endif

#define _rowread(x) \
  ({register short __r; \
  *(short*)0x600018=(short)(x); \
  asm volatile("move.w #24,%0;0:dbra %0,0b":"=g"(__r)::"memory"); \
  ~(*(unsigned char*)0x60001b);})

#define kbhit _rom_call(short,(void),52)
#define ngetchx _rom_call(short,(void),51)
#define pushkey _rom_call(void,(short),50)
#define GKeyIn _rom_call(short,(SCR_RECT*,short),17E)
#define GKeyDown _rom_call(short,(void),17F)
#define GKeyFlush _rom_call(void,(void),180)
#define OSGetStatKeys _rom_call(short,(void),299)
#define OSInitKeyInitDelay _rom_call(short,(short),248)
#define OSInitBetweenKeyDelay _rom_call(short,(short),249)

#ifdef DOORS

short kbhit(void);
short ngetchx(void);
void pushkey(short);
short GKeyIn(SCR_RECT*,short);
short GKeyDown(void);
void GKeyFlush(void);
short OSGetStatKeys(void);
short OSInitKeyInitDelay(short);
short OSInitBetweenKeyDelay(short);

#endif

#endif
