#ifndef __LINK
#define __LINK

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

#undef NULL
#undef size_t
#define NULL ((void*)0)
#define size_t unsigned long

#ifndef __BOOL
#define __BOOL

enum Bool {FALSE,TRUE};

#endif

#define reset_link _rom_call(void,(void),24C)
#define OSLinkReset _rom_call(void,(void),24C)
#define tx_free _rom_call(unsigned short,(void),252)
#define OSLinkTxQueueActive _rom_call(unsigned short,(void),252)
#define transmit _rom_call(short,(char*,short),250)
#define OSWriteLinkBlock _rom_call(short,(char*,short),250)
#define receive _rom_call(unsigned short,(char*,short),24F)
#define OSReadLinkBlock _rom_call(unsigned short,(char*,short),24F)

typedef struct
  {
    unsigned short hVar;
    union
      {
        const void *pVar;
        struct
          {
            unsigned short FindFlags;
            unsigned short NameSym;
          } DirVars;
      } extra;
    const char *VarName;
    unsigned short VarSize;
    unsigned short Index;
    unsigned short Unknown;
    unsigned char VarType;
    unsigned char VarCompat;
  } LIO_CTX;

#define OSLinkClose _rom_call(void,(void),24E)
#define OSLinkOpen _rom_call(void,(void),24D)
#define OSLinkTxQueueInquire _rom_call(unsigned short,(void),251)
#define flush_link _rom_call(void,(void),24D)

#define LIO_Send _rom_call(unsigned short,(LIO_CTX*,unsigned char),56)
#define LIO_Get _rom_call(unsigned short,(LIO_CTX*),57)
#define LIO_GetMultiple _rom_call(short,(LIO_CTX*),59)
#define LIO_SendData _rom_call(unsigned short,(void*,long),5A)
#define LIO_SendProduct _rom_call(unsigned short,(LIO_CTX*,unsigned char),253)
#define LIO_RecvData _rom_call(unsigned short,(void*,long,long),5B)
#define OSCheckSilentLink _rom_call(short,(void),24A)
#define OSLinkCmd _rom_call(void,(short),24B)
#define LIO_Receive _rom_call(unsigned short,(LIO_CTX*,unsigned short,short),58)

#define getcalc _rom_call(void,(char*),54)
#define sendcalc _rom_call(unsigned short,(char*,short,short,unsigned char*),55)

#ifdef DOORS

void reset_link(void);
void OSLinkReset(void);
unsigned short tx_free(void);
unsigned short OSLinkTxQueueActive(void);
short transmit(char*,short);
short OSWriteLinkBlock(char*,short);
unsigned short receive(char*,short);
unsigned short OSReadLinkBlock(char*,short);

void OSLinkClose(void);
void OSLinkOpen(void);
unsigned short OSLinkTxQueueInquire(void);
void flush_link(void);

unsigned short LIO_Send(LIO_CTX*,unsigned char);
unsigned short LIO_Get(LIO_CTX*);
short LIO_GetMultiple(LIO_CTX*);
unsigned short LIO_SendData(void*,long);
unsigned short LIO_SendProduct(LIO_CTX*,unsigned char);
unsigned short LIO_RecvData(void*,long,long);
short OSCheckSilentLink(void);
void OSLinkCmd(short);
unsigned short LIO_Receive(LIO_CTX*,unsigned short,short);

void getcalc(char*);
unsigned short sendcalc(char*,short,short,unsigned char*);

#endif

#endif

