#ifndef __RSA
#define __RSA

#ifndef NOSTUB
#ifndef DOORS
#ifndef USE_KERNEL
#include <nostub.h>
#else
#include <doors.h>
#endif
#endif
#endif

typedef struct
  {
    unsigned char Len;
    unsigned char Data[0];
  } BN;

typedef struct
  {
    unsigned long state[4]; 
    unsigned long count[2];     
    unsigned char buffer[64];
  } MD5_CTX;

#define BN_prodMod _rom_call(void,(BN*,BN*,BN*),124)
#define BN_powerMod _rom_call(void,(BN*,BN*,BN*,BN*),123)
#define BN_power17Mod _rom_call(void,(BN*,BN*,BN*),122)

#define cdecrypt _rom_call(void,(BN*,char*,long,BN*),127)

#define MD5Init _rom_call(void,(MD5_CTX*),254)
#define MD5Update _rom_call(void,(MD5_CTX*,char*,short),255)
#define MD5Final _rom_call(void,(char*,MD5_CTX*),256)
#define MD5Done _rom_call(void,(BN*,MD5_CTX*),257)

#ifdef DOORS

void BN_prodMod(BN*,BN*,BN*);
void BN_powerMod(BN*,BN*,BN*,BN*);
void BN_power17Mod(BN*,BN*,BN*);

void cdecrypt(BN*,char*,long,BN*);

void MD5Init(MD5_CTX*);
void MD5Update(MD5_CTX*,char*,short);
void MD5Final(char*,MD5_CTX*);
void MD5Done(BN*,MD5_CTX*);

#endif

#endif

